--- chars_cmds.c	2001-08-16 08:29:47.000000000 -0400
+++ chars_cmds.c	2014-12-28 22:28:05.000000000 -0500
@@ -98,6 +98,4 @@
 extern char *ie_call_function();
 
-FCT (static RETSIGTYPE, donothing, () );
-
 static char *cut_buffer = 0;
 static int n_cb = 0;
@@ -362,5 +360,5 @@
     int n;
 {
-  char *p;
+  const char *p;
   int mark = 0;
   int len, dn;
@@ -375,5 +373,5 @@
 
   mark = UpdateMark ( text, 0, -(n -1) );
-  p = (char *) DeleteLines ( text -> buf, n, &len, &dn );
+  p = DeleteLines ( text -> buf, n, &len, &dn );
   if ( mark ) 
     UpdateMarkPos (text );
@@ -421,5 +419,5 @@
     int i;
 {
-  char *p;
+  const char *p;
   int len, dn;
   
@@ -428,5 +426,5 @@
 
   TextCursorOff ( text );
-  p = (char *) RestoreKillBuf ( i, &len, &dn );
+  p = RestoreKillBuf ( i, &len, &dn );
   
   if ( p == 0 ) {
@@ -484,6 +482,6 @@
   ClearListBox ();
   KillBufferInList ();
-  str = (char *) SelectFromListBox ( "Kill Buffers" );
-  if ( str != 0 ) {
+  str = SelectFromListBox ();
+  if (str != NULL) {
     /* str += 9; */
     /* On vire le "Select : " */
@@ -510,5 +508,5 @@
 {
   int lines;
-  char *s;
+  const char *s;
   int nbytes;
   
@@ -532,5 +530,5 @@
       RefreshScrollBar ( dpy, text -> swin );
     }
-    (void) StoreInUndo ( text, s, (char *) 0, nbytes, lines, U_STD );
+    (void) StoreInUndo ( text, s, NULL, nbytes, lines, U_STD );
     
     /* Pour la couleur */
@@ -557,5 +555,5 @@
 void InsertLines ( text, s, nbytes, lines )
     Text *text;
-    char *s;
+    const char *s;
     int nbytes;
     int lines;
@@ -640,5 +638,6 @@
 {
   int lines;
-  char *s, *tmp = 0;
+  const char *s;
+  char *tmp = NULL;
   int mark = 0;
   int nbytes;
@@ -652,5 +651,5 @@
     return;
   
-  if ( (s != 0) && (nbytes != 0 )) {
+  if ( (s != NULL) && (nbytes != 0 )) {
     if ( (text -> modif == False) && (strcmp(text -> filename,"NoName")==0) )
       return;
@@ -701,5 +700,5 @@
       }
     }
-    tmp = (char *) malloc ( (unsigned) nbytes + 2 );
+    tmp = malloc (nbytes + 2);
     (void) bcopy ( RightBuf ( text -> buf ), tmp, nbytes );
     
@@ -728,5 +727,5 @@
       RefreshScrollBar ( dpy, text -> swin );
     }
-    (void) StoreInUndo ( text, tmp, (char *) 0, -nbytes, lines, U_STD );
+    (void) StoreInUndo ( text, tmp, NULL, -nbytes, lines, U_STD );
     (void) StoreInKillBuf ( tmp, nbytes, lines );
     
@@ -743,6 +742,4 @@
   }
 }
-static int timer_expire = False;
-static RETSIGTYPE donothing () { timer_expire = True; }
 
 
@@ -783,87 +780,20 @@
 
 
-/*
-**	Function name : FunctionHeader
-**
-**	Description : 
-**	Input : 
-**	Ouput :
-*/
-void FunctionHeader ( text )
-    Text *text;
-{
-  char *msg;
-  int nw = text->win_id;
-  
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "function_header", 0, 0);
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-}
-
-
-/*
-**	Function name : IncludeHeader
-**
-**	Description : 
-**	Input : 
-**	Ouput :
-*/
-void IncludeHeader ( text )
-    Text *text;
+static void commonf(Text *text, const char *funcname)
 {
-  char *msg;
+  const char *msg;
   int nw = text->win_id;
   
   StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "include_header", 0, 0) ;
+  msg = ie_call_function ( text, funcname, 0, 0) ;
   text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-}
-
-/*
-**	Function name : ClassHeader
-**
-**	Description : 
-**	Input : 
-**	Ouput :
-*/
-void ClassHeader ( text )
-    Text *text;
-{
-  char *msg;
-  int nw = text->win_id;
-    
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "class_header", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-}
-
-/*
-**	Function name : MethodHeader
-**
-**	Description : 
-**	Input : 
-**	Ouput :
-*/
-void MethodHeader ( text )
-    Text *text;
-{
-  char *msg;
-  int nw = text->win_id;
-
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "method_header", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
+  if (msg != NULL)
+    DisplayMessage(text -> mwin, msg);
+  ie_redisplay (text);
+  if (TextInBuf(text) == False) {
+     TextCursorOff(text);
+     ClearPage(text);
+     TextCursorOn(text);
+  }  
 }
 
@@ -878,19 +808,5 @@
     Text *text;
 {
-  char *msg;
-  int nw = text->win_id;
-
-  StorePosition ( text );
-/*  msg = (char *) ie_call_function ( text, "add_header", 0, 0) ;*/
-  msg = (char *) ie_call_function ( text, "programming_utilities", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-  if(TextInBuf(text)==False){
-     TextCursorOff(text);
-     ClearPage(text);
-     TextCursorOn(text);
-  }  
+  commonf(text, "programming_utilities");
 }
 
@@ -905,18 +821,5 @@
     Text *text;
 {
-  char *msg;
-  int nw = text->win_id;
-
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "rcs_commands", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-  if(TextInBuf(text)==False){
-     TextCursorOff(text);
-     ClearPage(text);
-     TextCursorOn(text);
-  }  
+  commonf(text, "rcs_commands");
 }
 
@@ -932,18 +835,5 @@
     Text *text;
 {
-  char *msg;
-  int nw = text->win_id;
-
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "latex_macros", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-  if(TextInBuf(text)==False){
-     TextCursorOff(text);
-     ClearPage(text);
-     TextCursorOn(text);
-  }  
+  commonf(text, "latex_macros");
 }
 
@@ -958,18 +848,5 @@
     Text *text;
 {
-  char *msg;
-  int nw = text->win_id;
-
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "html_macros", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-  if(TextInBuf(text)==False){
-     TextCursorOff(text);
-     ClearPage(text);
-     TextCursorOn(text);
-  }  
+  commonf(text, "html_macros");
 }
 
@@ -984,18 +861,5 @@
     Text *text;
 {
-  char *msg;
-  int nw = text->win_id;
-
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "misc_commands", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay (text);
-  if(TextInBuf(text)==False){
-     TextCursorOff(text);
-     ClearPage(text);
-     TextCursorOn(text);
-  }  
+  commonf(text, "misc_commands");
 }
 
@@ -1010,18 +874,5 @@
     Text *text;
 {
-  char *msg;
-  int nw = text->win_id;
-
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "user_commands", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-  if(TextInBuf(text)==False){
-     TextCursorOff(text);
-     ClearPage(text);
-     TextCursorOn(text);
-  }  
+  commonf(text, "user_commands");
 }
 
@@ -1036,18 +887,5 @@
     Text *text;
 {
-  char *msg;
-  int nw = text->win_id;
-
-  StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "edir", 0, 0) ;
-  text = update_cwd(nw);
-  if ( msg != 0 )
-    DisplayMessage ( text -> mwin, msg );
-  ie_redisplay ( text );
-  if(TextInBuf(text)==False){
-     TextCursorOff(text);
-     ClearPage(text);
-     TextCursorOn(text);
-  }  
+  commonf(text, "edir");
 }
 
@@ -1130,9 +968,9 @@
 */
 void Store_bytes(s, n)
-    char *s; int n;
+    const char *s; int n;
 {
   Clear_bytes();
   
-  cut_buffer = (char *) malloc (n+2);
+  cut_buffer = malloc (n+2);
   bzero (cut_buffer, n+2);
   strncpy (cut_buffer, s, n);
@@ -1147,5 +985,5 @@
 **	Output :
 */
-char *Fetch_bytes(n)
+const char *Fetch_bytes(n)
     int *n;
 {
@@ -1166,5 +1004,5 @@
     free (cut_buffer);
     n_cb = 0;
-    cut_buffer = 0;
+    cut_buffer = NULL;
   }
 }
--- chars_cmds.h	2001-01-20 10:34:49.000000000 -0500
+++ chars_cmds.h	2014-12-28 22:15:27.000000000 -0500
@@ -51,10 +51,6 @@
 FCT (void, DisplayKillBuffer, (Text *text) );
 FCT (void, GetBytesFromCutBuffer, (Text *text) );
-FCT (void, InsertLines, (Text *text, char *s, int nbytes, int lines) );
+FCT (void, InsertLines, (Text *text, const char *s, int nbytes, int lines) );
 
-FCT (void, ClassHeader, (Text *text) );
-FCT (void, FunctionHeader, (Text *text) );
-FCT (void, MethodHeader, (Text *text) );
-FCT (void, IncludeHeader, (Text *text) );
 FCT (void, LatexMacros, (Text *text) );
 FCT (void, ProgrammingUtil, (Text *text) );
@@ -73,7 +69,7 @@
 FCT (void, f_tab, (Text *text) );
 FCT (void, QuotedChar, (Text *text) );
-FCT (void, Store_bytes, (char *s, int n) );
-FCT (char *, Fetch_bytes, (int *n) );
-FCT (void, Clear_bytes, () );
+FCT (void, Store_bytes, (const char *s, int n) );
+FCT (const char *, Fetch_bytes, (int *n) );
+FCT (void, Clear_bytes, (void) );
 
 #endif /* _CHARS_CMDS_H_ */
--- input_str.c	2000-04-06 16:55:48.000000000 -0400
+++ input_str.c	2014-12-28 21:48:13.000000000 -0500
@@ -84,4 +84,6 @@
 #include "shadow.h"
 #include "input_str.h"
+#include "fs_box.h"
+#include "Smac/smacXcoral.h"
 
 Text *input_str;
@@ -104,16 +106,15 @@
 #define MINIB_CANCEL 4
 
-char *str_buf;
+static char *str_buf;
 int str_buf_len;
 #define STR_BUF_LEN 64
 
 FCT (static void, CleanInputStr, () );
-FCT (static int, CommonLength, (char *s, int ns, int r) );
-FCT (static void, ConfigInputString, () );
-FCT (static char *, ExpandFileName, (char *s, int *n, int *common) );
-FCT (static void, ExposeInputString, () );
-FCT (void, InputStrSave, (char *s, int len) );
-FCT (static void, InputStrUnmap, () );
-FCT (static void, PrintMatchedNames, (char *s, int combien) );
+FCT (static int, CommonLength, (const char *s, int ns, int r) );
+FCT (static void, ConfigInputString, (void) );
+FCT (static char *, ExpandFileName, (const char *s, int *n, int *common) );
+FCT (static void, ExposeInputString, (void) );
+FCT (static void, InputStrUnmap, (void) );
+FCT (static void, PrintMatchedNames, (const char *s, int combien) );
 
 extern Atom prop_sel;
@@ -171,15 +172,15 @@
     }
     
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^A", "goto_beginning_of_line" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^B", "goto_previous_char" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^D", "delete_char" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^E", "goto_end_of_line" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^F", "goto_next_char" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^G", "str_abort" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^H", "delete" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^K", "kill_line" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^M", "str_return" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^I", "str_tab" );
-    ie_key_def ( input_str,"input_str" , (unsigned char *)"^P", "str_previous" );
+    ie_key_def ("input_str" , "^A", "goto_beginning_of_line");
+    ie_key_def ("input_str" , "^B", "goto_previous_char");
+    ie_key_def ("input_str" , "^D", "delete_char");
+    ie_key_def ("input_str" , "^E", "goto_end_of_line");
+    ie_key_def ("input_str" , "^F", "goto_next_char");
+    ie_key_def ("input_str" , "^G", "str_abort");
+    ie_key_def ("input_str" , "^H", "delete");
+    ie_key_def ("input_str" , "^K", "kill_line");
+    ie_key_def ("input_str" , "^M", "str_return");
+    ie_key_def ("input_str" , "^I", "str_tab");
+    ie_key_def ("input_str" , "^P", "str_previous");
 
     input_str -> current_mode -> key [DELETE].func = ie_WR_delete_char;
@@ -210,9 +211,9 @@
 **	Ouput :
 */
-char *InputString ( parent, raise, gc, font, prompt, reply )
+const char *InputString ( parent, raise, gc, font, prompt, reply )
     Window parent, raise;
     GC gc;
     XFontStruct *font;
-    char *prompt;
+    const char *prompt;
     int reply;
 {
@@ -221,5 +222,5 @@
     XWindowAttributes att;
     int len;
-    char *str, *s;
+    const char *str, *s;
     int lines;
     int nbytes;
@@ -502,7 +503,7 @@
 **	Ouput : La chaine
 */
-char *GetString ( text, prompt, reply )
+const char *GetString ( text, prompt, reply )
     Text *text;
-    char *prompt;
+    const char *prompt;
     int reply;
 {
@@ -519,10 +520,9 @@
         /* 100 pixels, c'est le minimum, 7,8,9 caracteres
 	   suivant la fonte */
-	return ( (char *) GetStringFromDB ( prompt, reply ));
+	return (GetStringFromDB ( prompt, reply ));
     }
     else {
         /* Mini-Buffer */
-	return ( (char *)
-		InputString ( text -> mwin -> mess, 0,
+	return (InputString (text -> mwin -> mess, 0,
 			     text -> mwin -> mess_gc,
 			     text -> mwin -> font, prompt, reply ));
@@ -632,18 +632,14 @@
 */
 void InputStrSave ( s, len )
-    char *s;
+    const char *s;
     int len;
 {
     if ( len > (str_buf_len - 1) ) {
-	(void) free ( str_buf );
-	str_buf = (char *) malloc ( (unsigned) (len + 2));
-	(void) strncpy ( str_buf, s, len );
-	str_buf [len] = 0;
+	free(str_buf);
+	str_buf = malloc((len + 2));
 	str_buf_len = len + 2;
     }
-    else {
 	(void) strncpy ( str_buf, s, len );
-	str_buf [len] = 0;
-    }
+    str_buf [len] = '\0';
 }
 
@@ -655,6 +651,5 @@
 **	Ouput :
 */
-void InputStrPrevious ( text )
-    Text *text;
+void InputStrPrevious ()
 {
     TextCursorOff ( input_str );
@@ -675,6 +670,5 @@
 **	Ouput :
 */
-void InputStrReturn ( text )
-    Text *text;
+void InputStrReturn ()
 {
     str_status = STR_RETURN;
@@ -688,6 +682,5 @@
 **	Ouput :
 */
-void InputStrAbort ( text )
-    Text *text;
+void InputStrAbort ()
 {
     str_status = STR_ABORT;
@@ -702,5 +695,5 @@
 */
 static char * ExpandFileName (s, n, common)
-    char * s;
+    const char * s;
     int * n;
     int * common;
@@ -708,6 +701,7 @@
     DIR * dp;
     struct dirent * entry;
-    char * result = 0;
+    char * result = NULL;
     int rlength = 0;
+    int dirlen;
     char * current_dir;
     
@@ -715,48 +709,47 @@
     
     {
-	char *fsdirname, *newdir;
-	char *slash;
+	const char *fsdirname;
+	const char *slash;
 	
-	fsdirname = (char *) GetFsBoxInternalDir();
+	fsdirname = GetFsBoxInternalDir();
 	slash = strrchr(s, '/');
 
 	if (fsdirname) {
 	    /* On est dans le file selecteur */
-	    if(slash) {
+	    if (slash) {
 		if (strlen(s)==1 && *s == '/') /* C'est la racine */
-		  ;
+		  dirlen = 1;
 		else
-		  *slash = 0; /* Pour que s soit une directorie */
+		  dirlen = slash - s; /* Pour que s soit une directorie */
 		if (*s != '/') {
 		    /* on part de fsdirname */
-		    newdir = (char *)malloc(strlen(fsdirname)+strlen(s)+2);
-		    sprintf(newdir,"%s%s",fsdirname, s);
-		    dp = opendir(newdir);
-		    current_dir = (char *) stringdup(newdir);
-		    free(newdir);
+		    current_dir = malloc(strlen(fsdirname) + dirlen + 2);
+		    sprintf(current_dir,"%s%.*s",fsdirname, dirlen, s);
+		    dp = opendir(current_dir);
 		}
 		else {
 		  dp = opendir(s);
-		  current_dir = (char *) stringdup(s);
+		  current_dir = strdup(s);
 		}
-		*slash = '/';
 		s = slash + 1;
 	    }
 	    else {
 		dp = opendir(fsdirname);
-		current_dir = (char *) stringdup(fsdirname);
+		current_dir = strdup(fsdirname);
 	    }
 	}
 	else {
 	    if (slash) {
-		*slash = 0;
-		dp = opendir(s);
-		current_dir = (char *) stringdup(s);
-		*slash = '/';
+		dirlen = slash - s;
+		if (dirlen == 0)
+		  dirlen = 1;
+		current_dir = malloc(dirlen + 1);
+		bcopy(s, current_dir, dirlen);
+		dp = opendir(current_dir);
 		s = slash + 1;
 	    }
 	    else {
 		dp = opendir(".");
-		current_dir = (char *) stringdup(".");
+		current_dir = strdup(".");
 	    }
 	}
@@ -765,5 +758,5 @@
     
     if (! dp)
-      return 0;
+      return NULL;
     
     *common = strlen(s);
@@ -772,5 +765,5 @@
       if (strstr(entry->d_name, s) == entry->d_name) {
 	char * nresult =
-	  (char *) malloc((unsigned int) rlength + NAMLEN(entry) + 1 + 1);
+	  malloc(rlength + NAMLEN(entry) + 1 + 1);
 	
 	if (! nresult) {
@@ -816,5 +809,5 @@
 */
 static int CommonLength(s, ns, r)
-    char * s;
+    const char * s;
     int ns;
     int r;
@@ -825,5 +818,5 @@
     
     while ((c = s[++r])) {
-	char * p = s;
+	const char * p = s;
 	int n = ns - 1;
 	
@@ -847,9 +840,9 @@
 */
 static void PrintMatchedNames(s, combien )
-    char * s;
+    const char * s;
     int combien;
 {
     char *tmp;
-    char *str = s;
+    const char *str = s;
     int len, i;
     
@@ -859,5 +852,5 @@
 	s += strlen ( s ) + 1;
     }
-    tmp = (char *) malloc ( (unsigned int) len + combien + 2 );
+    tmp = malloc (len + combien + 2 );
     bzero ( tmp, len + combien + 2 );
     for ( i=0; i<combien; i++ ) {
@@ -867,5 +860,5 @@
     }
     DisplayWMessage ( tmp, " Matched Names", True );
-    (void) free ( tmp );
+    free ( tmp );
 }
 
@@ -877,8 +870,8 @@
 **	Ouput :
 */
-void InputStrTab ( text )
-    Text *text;
+void InputStrTab ()
 {
-    char *s, *t_str;
+    const char *s, *spacep;
+    char *t_str;
     int len, combien;
 /*
@@ -888,17 +881,19 @@
     }
 */
-    s = (char *) GetCurrentLine ( input_str -> buf, &len );
-    s[input_str -> buf -> l_cur - input_str -> buf -> top] = 0;
+    s = GetCurrentLine ( input_str -> buf, &len );
     
-    {
       /* recherche le dernier mot */
-      char * spacep = strrchr(s, ' ');
+    for (spacep = s + (input_str->buf->l_cur - input_str->buf->top);
+	 spacep != s; spacep--) {
+      if (*spacep == ' ')
+	break;
+    }
 
-      if (spacep)
+    if (spacep != s)
         s = spacep + 1;
-    }
+ 
     TextCursorOff ( input_str );
     if (*s == '~') {
-      char * expandtilde = (char *) ExpandTildeName (s);
+      const char * expandtilde = ExpandTildeName (s);
 
       DeleteNchar(input_str -> buf, strlen(s));
@@ -907,7 +902,7 @@
     }
     if ( mb_context == CTX_EVAL_EXP )
-      t_str = (char *) ExpandSmacName ( s, &combien, &len);
+      t_str = ExpandSmacName ( s, &combien, &len);
     else
-      t_str = (char *) ExpandFileName ( s, &combien, &len);
+      t_str = ExpandFileName ( s, &combien, &len);
     if ( combien == 0 )
       klaxon ();
@@ -932,21 +926,13 @@
 }
 
-/*
-**	Function name : ExpandTildeName
-**
-**	Description : 
-**	Input : 
-**	Ouput :
-*/
-char *ExpandTildeName ( name )
-    char *name;
+const char *ExpandTildeName ( name )
+    const char *name;
 {
     struct passwd *pwd;
     char *home;
-    char *p = name + 1;
     static char  buf_dir_tmp [MAXPATHLEN];
     
     if ( name [1] == '/' || name [1] == '\0') {   /* c'est moi */
-	if ( (home = (char *) getenv ( "HOME" )) == 0 )
+	if ((home = getenv ("HOME")) == NULL)
 	  return name;
 	(void) strcpy ( buf_dir_tmp, home );
@@ -954,11 +940,11 @@
     }
     else { /* c'est un autre */
-	int save;
+	const char *p;
+	char *pb;
 	
-	while ( *p && *p != '/' ) p++;
-	save = *p;
-	*p = 0;
-	pwd = getpwnam ( name + 1 );
-	*p = save;
+	for (p = name + 1, pb = buf_dir_tmp; *p && *p != '/'; p++)
+	  *pb++ = *p;
+	*pb = 0;
+	pwd = getpwnam (buf_dir_tmp);
 	if (  pwd ) {
 	    (void) strcpy ( buf_dir_tmp, pwd ->  pw_dir);
@@ -979,7 +965,7 @@
 */
 void FillMiniBuffer ( str )
-    char *str;
+    const char *str;
 {
-    if ( (str == 0) || (strlen(str)== 0) )
+    if (str == NULL || str[0] == '\0')
       return;
     
--- main_buffer.c	1998-09-20 13:01:18.000000000 -0400
+++ main_buffer.c	2014-12-28 22:11:41.000000000 -0500
@@ -539,5 +539,5 @@
 void InsertNchar ( buf, s, n )
     Buf *buf;
-    char *s;
+    const char *s;
     int n;
 {
@@ -601,5 +601,5 @@
 */
 char *GetForwardLine ( buf, n, len )
-    Buf *buf;
+    const Buf *buf;
     int n;
     int *len;	/* Return */
@@ -644,5 +644,5 @@
 */
 char *GetBackwardLine ( buf, n, len )
-    Buf *buf;
+    const Buf *buf;
     int n;
     int *len; /* Return */
@@ -694,5 +694,5 @@
 */
 char *GetCurrentLine ( buf, len )
-    Buf *buf;
+    const Buf *buf;
     int *len; /* Return */
 {
@@ -819,5 +819,5 @@
 */
 int GetNcFromLeft ( buf )
-    Buf *buf;
+    const Buf *buf;
 {
     int n = 0;
@@ -851,5 +851,5 @@
 */
 int GetNcFromRight ( buf )
-    Buf *buf;
+    const Buf *buf;
 {
     int n = 0;
@@ -879,5 +879,5 @@
 */
 int GetNumberOfLineInBuf ( buf )
-    Buf *buf;
+    const Buf *buf;
 {
     int n = 1;
@@ -928,8 +928,8 @@
 */
 int GetNewLine ( t, len )
-    char *t; /* le texte */
+    const char *t; /* le texte */
     int len; /* la longeur du texte */
 {
-    char *start = t;
+    const char *start = t;
     int nl = 0;
     
@@ -962,5 +962,5 @@
 */
 int GetCurrentChar ( buf, c )
-    Buf *buf;
+    const Buf *buf;
     char *c; /* Return */
 {
@@ -984,5 +984,5 @@
 */
 void GetPrevChar ( buf, c )
-    Buf *buf;
+    const Buf *buf;
     char *c;
 {
@@ -1006,5 +1006,5 @@
 **		des lignes
 */
-char *DeleteLines ( buf, n, len, dn )
+const char *DeleteLines ( buf, n, len, dn )
     Buf *buf;
     int n;      /* nb lignes demandees */
--- main_buffer.h	1995-03-17 03:08:33.000000000 -0500
+++ main_buffer.h	2014-12-28 22:08:55.000000000 -0500
@@ -59,19 +59,19 @@
 FCT (void, ClearBuffer, (Buf *buf) );
 FCT (void, DeleteBuffer, (Buf *buf) );
-FCT (char *, DeleteLines, (Buf *buf, int n, int *len, int *dn) );
+FCT (const char *, DeleteLines, (Buf *buf, int n, int *len, int *dn) );
 FCT (void, DeleteNchar, (Buf *buf, int n) );
-FCT (char *, GetBackwardLine, (Buf *buf, int n, int *len) );
+FCT (char *, GetBackwardLine, (const Buf *buf, int n, int *len) );
 FCT (Buf *, GetBuffer, (unsigned int size) );
-FCT (int, GetCurrentChar, (Buf *buf, char *c) );
-FCT (char *, GetCurrentLine, (Buf *buf, int *len) );
-FCT (char *, GetForwardLine, (Buf *buf, int n, int *len) );
-FCT (int, GetNcFromLeft, (Buf *buf) );
-FCT (int, GetNcFromRight, (Buf *buf) );
-FCT (int, GetNewLine, (char *t, int len) );
-FCT (int, GetNumberOfLineInBuf, (Buf *buf) );
-FCT (void, GetPrevChar, (Buf *buf, char *c) );
+FCT (int, GetCurrentChar, (const Buf *buf, char *c) );
+FCT (char *, GetCurrentLine, (const Buf *buf, int *len) );
+FCT (char *, GetForwardLine, (const Buf *buf, int n, int *len) );
+FCT (int, GetNcFromLeft, (const Buf *buf) );
+FCT (int, GetNcFromRight, (const Buf *buf) );
+FCT (int, GetNewLine, (const char *t, int len) );
+FCT (int, GetNumberOfLineInBuf, (const Buf *buf) );
+FCT (void, GetPrevChar, (const Buf *buf, char *c) );
 FCT (void, HoleToLeft, (Buf *buf) );
 FCT (void, HoleToRight, (Buf *buf) );
-FCT (void, InsertNchar, (Buf *buf, char *s, int n) );
+FCT (void, InsertNchar, (Buf *buf, const char *s, int n) );
 FCT (int, LoadFileInBuffer, (Buf *buf, FILE *fd, int len, int flag) );
 FCT (int, MoveHole, (Buf *buf, int n) );
--- main_events.c	2006-12-16 10:43:49.000000000 -0500
+++ main_events.c	2014-12-28 22:32:27.000000000 -0500
@@ -39,4 +39,6 @@
 
 #include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
 #include <setjmp.h>
 #include <signal.h>
@@ -47,4 +49,5 @@
 #include <sys/select.h>
 #endif
+#include <err.h>
 
 #include <X11/Xlib.h>
@@ -63,4 +66,5 @@
 #include "ctr_panel.h"
 #include "main_events.h"
+#include "parse.h"
 #include "process.h"
 #include "new_window.h"
@@ -71,7 +75,11 @@
 #include "cb_names.h"
 #include "get_file.h"
+#include "scroll.h"
 #include "selection.h"
 #include "tbox.h"
 #include "options.h"
+#include "ie_func.h"
+#include "Smac/smacXcoral.h"
+#include "tool_bar.h"
 
 EdWin	*CreateWindow ();
@@ -90,17 +98,14 @@
 static XEvent *ev = &event;
 
-extern void exit ();
-extern int ToolBarButton();
-
 FCT (static void, ButtonPressInControl, (XEvent *ev, Text *text, int i) );
-FCT (static void, HandleKeyPress, () );
-FCT (static void, HandleKeyRelease, () );
-FCT (static void, HandleMap, () );
-FCT (static void, HandleMessage, () );
-FCT (static void, HandleSelectionRequest, () );
-FCT (static void, HandleSelectionNotify, () );
-FCT (static void, HandlePropertyNotify, () );
-FCT (static void, IgnoreEvent, () );
-FCT (static void, ButtonUserFunc, (Text *text, int x, int y, char *func_name) );
+FCT (static void, HandleKeyPress, (void) );
+FCT (static void, HandleKeyRelease, (void) );
+FCT (static void, HandleMap, (void) );
+FCT (static void, HandleMessage, (void) );
+FCT (static void, HandleSelectionRequest, (void) );
+FCT (static void, HandleSelectionNotify, (void) );
+FCT (static void, HandlePropertyNotify, (void) );
+FCT (static void, IgnoreEvent, (void) );
+FCT (static void, ButtonUserFunc, (Text *text, int x, int y, const char *func_name) );
 
 #define MAX_EVENT 64
@@ -422,6 +427,5 @@
   XSelectionEvent ev_not;
   int nbytes = 0;
-  char *s;
-  int result;
+  const char *s;
 
 #ifdef DEBUG
@@ -436,5 +440,5 @@
   s = Fetch_bytes (&nbytes);
 
-  if (s == 0 || nbytes == 0) {
+  if (s == NULL || nbytes == 0) {
 #ifdef DEBUG
     (void) fprintf ( stderr, "Selection Request null\n" );
@@ -451,17 +455,7 @@
 				ev -> xselectionrequest.target : ev -> xselectionrequest.property);
 
-  if ((ev -> xselectionrequest.selection == XA_PRIMARY)
-      &&((ev -> xselectionrequest.target == XA_STRING)
-	|| strcmp(XGetAtomName(dpy,ev_not.target),"COMPOUND_TEXT") ==0) 
-      &&(ev -> xselectionrequest.property)) {
-    {
       XChangeProperty (dpy, ev_not.requestor, ev_not.property,
 		       ev_not.target, 8, PropModeReplace,
 		       (unsigned char *) s, nbytes );
-    }
-  }
-  else {
-    ev_not.property = None;
-  }
 
   XSendEvent (dpy, ev_not.requestor, False, 0L, (XEvent *) &ev_not);
@@ -883,5 +877,5 @@
 	return;
     }
-    if ( ToolBarButton ( edwin, (XButtonEvent *) ev ) == True ) {
+    if ( ToolBarButton ( edwin, ev ) == True ) {
       return;
     }
@@ -994,5 +988,5 @@
 	    }
 	    TextCursorOn ( edwin -> text );
-	    selection_time = HandleSelection (edwin -> text, ev);
+	    selection_time = HandleSelection(edwin -> text);
 	    if (edwin -> text -> selection -> select == True) {
 	      /* Il faut effacer la derniere selection si elle existe */
@@ -1164,5 +1158,5 @@
     Text *text;
     int x, y;
-    char *func_name;
+    const char *func_name;
 {
     int old_x = text -> x_pos;
--- mark_reg.c	2000-12-26 10:14:59.000000000 -0500
+++ mark_reg.c	2014-12-28 00:18:17.000000000 -0500
@@ -43,4 +43,10 @@
 #include <X11/Xutil.h>
 
+#if HAVE_STRING_H
+#include <string.h>
+#else
+#include <strings.h>
+#endif
+
 #include "main_text.h"
 #include "mark_reg.h"
@@ -54,4 +60,5 @@
 #include "kill_buf.h"
 #include "selection.h"
+#include "Smac/smacXcoral.h"
 
 /* #define DEBUG */
@@ -65,5 +72,5 @@
 FCT (static int, OnMark, (Text *text, int len, int lines) );
 FCT (static void, SmallRegion, (Text *text, int op) );
-FCT (static void, eval_expression, (Text *text, char *str) );
+FCT (static void, eval_expression, (Text *text, const char *str) );
 
 static int ml, mp;
@@ -617,5 +624,5 @@
     int diff, lines;
     int len;
-    char *p;
+    const char *p;
     char buf [32];    
     
@@ -757,9 +764,9 @@
     Text *text;
 {
-  char *msg;
+  const char *msg;
   int nw = text->win_id;
 
   StorePosition ( text );
-  msg = (char *) ie_call_function ( text, "indent_region", 0, 0) ;
+  msg = ie_call_function ( text, "indent_region", 0, 0) ;
   text = update_cwd(nw);
   if ( msg != 0 )
@@ -778,9 +785,9 @@
     Text *text;
 {
-    char *msg;
+    const char *msg;
     int nw = text->win_id;
     
     StorePosition ( text );
-    msg = (char *) ie_eval_region (text) ;
+    msg = ie_eval_region (text) ;
     text = update_cwd(nw);
     
@@ -800,12 +807,12 @@
 static void eval_expression ( text, str )
     Text *text;
-    char *str;
+    const char *str;
 {
-    char *msg;
+    const char *msg;
     int nw = text->win_id;
     
     if ( str == 0 )
       return;
-    msg = (char *) ie_eval_expression ( text, str );
+    msg = ie_eval_expression ( text, str );
     text = update_cwd(nw);
     
@@ -827,5 +834,5 @@
     Text *text;
 {
-    char *str;
+    const char *str;
     char c = '\007'; /* ^G */
 
@@ -853,5 +860,5 @@
     Text *text;
 {
-    char *str;
+    const char *str;
     char c = '\007'; /* ^G */
     
@@ -863,5 +870,5 @@
     StorePosition ( text );
     SetMBcontext ( CTX_EVAL_EXP );
-    str = (char *) GetStringFromDB ( "Eval expression : ", False );
+    str = GetStringFromDB ( "Eval expression : ", False );
     SetMBcontext ( CTX_FILE );
   
@@ -884,8 +891,8 @@
     Text *text;
 {
-  char *msg;
+  const char *msg;
 
   StorePosition (text);
-  msg = (char *) ie_call_function ( text, "color_region", 0, 0);
+  msg = ie_call_function ( text, "color_region", 0, 0);
   if ( msg != 0 )
     DisplayMessage ( text -> mwin, msg );
@@ -903,8 +910,8 @@
     Text *text;
 {
-  char *msg;
+  const char *msg;
 
   StorePosition (text);
-  msg = (char *) ie_call_function ( text, "color_buffer", 0, 0);
+  msg = ie_call_function ( text, "color_buffer", 0, 0);
   if ( msg != 0 )
     DisplayMessage ( text -> mwin, msg );
@@ -921,8 +928,8 @@
     Text *text;
 {
-  char *msg;
+  const char *msg;
 
   StorePosition (text);
-  msg = (char *) ie_call_function ( text, "remove_colors", 0, 0);
+  msg = ie_call_function ( text, "remove_colors", 0, 0);
   if ( msg != 0 )
     DisplayMessage ( text -> mwin, msg );
@@ -1066,5 +1073,5 @@
   int lines;
   int len;
-  char *p;
+  const char *p;
   
   if ( text -> markline == 0 )
